Debian Bug report logs - #702421
link-mode persistence broken due to wrong link targets

version graph

Package: live-boot; Maintainer for live-boot is Live Systems Maintainers <debian-live@lists.debian.org>; Source for live-boot is src:live-boot.

Reported by: Evgeni Golov <evgeni@debian.org>

Date: Wed, 6 Mar 2013 11:06:01 UTC

Severity: normal

Found in version live-boot/3.0.0-1

Fixed in version live-boot/4.0~a8-1

Done: Daniel Baumann <daniel@debian.org>

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, evgeni@debian.org, mika@grml.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#702421; Package live-boot. (Wed, 06 Mar 2013 11:06:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Evgeni Golov <evgeni@debian.org>:
New Bug report received and forwarded. Copy sent to evgeni@debian.org, mika@grml.org, Debian Live Project <debian-live@lists.debian.org>. (Wed, 06 Mar 2013 11:06:03 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Evgeni Golov <evgeni@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: link-mode persistence broken due to wrong link targets
Date: Wed, 06 Mar 2013 12:02:20 +0100
Package: live-boot
Version: 3.0.0-1
Severity: important

Hi,

the fix for #696495 (d2b2a46118d331a5b3c0218c475da8e5aa831df8) broke
link-mode persistence as the links now show to /live/persistence/...
while the mount was moved to /lib/live/mount/persistence/... when the
system was booted up.

Before that commit the links were properly set to the /lib/live location.

Regards
Evgeni

-- System Information:
Debian Release: 7.0
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (1, 'experimental')
Architecture: amd64 (x86_64)
Foreign Architectures: i386

Kernel: Linux 3.7-trunk-amd64 (SMP w/4 CPU cores)
Locale: LANG=en_US.UTF-8, LC_CTYPE=en_US.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash



Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#702421; Package live-boot. (Wed, 06 Mar 2013 13:18:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Evgeni Golov <evgeni@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Wed, 06 Mar 2013 13:18:03 GMT) Full text and rfc822 format available.

Message #10 received at 702421@bugs.debian.org (full text, mbox):

From: Evgeni Golov <evgeni@debian.org>
To: 702421@bugs.debian.org
Cc: Evgeni Golov <evgeni@grml.org>
Subject: [PATCH 3/3] transform link targets so they work *after* the mount was moved
Date: Wed, 6 Mar 2013 14:04:42 +0100
From: Evgeni Golov <evgeni@grml.org>

Closes: #702421
---
 scripts/boot/9990-misc-helpers.sh |   14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

diff --git a/scripts/boot/9990-misc-helpers.sh b/scripts/boot/9990-misc-helpers.sh
index 6fda056..d775181 100755
--- a/scripts/boot/9990-misc-helpers.sh
+++ b/scripts/boot/9990-misc-helpers.sh
@@ -1149,12 +1149,12 @@ link_files ()
 	# is non-empty, remove mask from all source paths when
 	# creating links (will be necessary if we change root, which
 	# live-boot normally does (into $rootmnt)).
-	local src_dir dest_dir src_mask
+	local src_dir dest_dir src_transform
 
 	# remove multiple /:s and ensure ending on /
 	src_dir="$(trim_path ${1})/"
 	dest_dir="$(trim_path ${2})/"
-	src_mask="${3}"
+	src_transform="${3}"
 
 	# This check can only trigger on the inital, non-recursive call since
 	# we create the destination before recursive calls
@@ -1181,12 +1181,12 @@ link_files ()
 				chown_ref "${src}" "${dest}"
 				chmod_ref "${src}" "${dest}"
 			fi
-			link_files "${src}" "${dest}" "${src_mask}"
+			link_files "${src}" "${dest}" "${src_transform}"
 		else
 			final_src=${src}
-			if [ -n "${src_mask}" ]
+			if [ -n "${src_transform}" ]
 			then
-				final_src="$(echo ${final_src} | sed "s|^${src_mask}||")"
+				final_src="$(echo ${final_src} | sed "${src_transform}")"
 			fi
 			rm -rf "${dest}" 2> /dev/null
 			ln -s "${final_src}" "${dest}"
@@ -1511,7 +1511,7 @@ activate_custom_mounts ()
 		local cow_dir links_source
 		if [ -n "${opt_link}" ] && [ -z "${PERSISTENCE_READONLY}" ]
 		then
-			link_files ${source} ${dest} ${rootmnt}
+			link_files ${source} ${dest} "s|^/live/|/lib/live/mount/|"
 		elif [ -n "${opt_link}" ] && [ -n "${PERSISTENCE_READONLY}" ]
 		then
 			mkdir -p ${rootmnt}/lib/live/mount/persistence
@@ -1528,7 +1528,7 @@ activate_custom_mounts ()
 			chown_ref "${source}" "${cow_dir}"
 			chmod_ref "${source}" "${cow_dir}"
 			do_union ${links_source} ${cow_dir} ${source} ${rootfs_dest_backing}
-			link_files ${links_source} ${dest} ${rootmnt}
+			link_files ${links_source} ${dest} "s|^${rootmnt}||"
 		elif [ -n "${opt_union}" ] && [ -z "${PERSISTENCE_READONLY}" ]
 		then
 			do_union ${dest} ${source} ${rootfs_dest_backing}
-- 
1.7.10.4




Severity set to 'normal' from 'important' Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Wed, 06 Mar 2013 14:36:12 GMT) Full text and rfc822 format available.

Reply sent to Daniel Baumann <daniel@debian.org>:
You have taken responsibility. (Sun, 10 Mar 2013 18:21:03 GMT) Full text and rfc822 format available.

Notification sent to Evgeni Golov <evgeni@debian.org>:
Bug acknowledged by developer. (Sun, 10 Mar 2013 18:21:04 GMT) Full text and rfc822 format available.

Message #17 received at 702421-close@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 702421-close@bugs.debian.org
Subject: Bug#702421: fixed in live-boot 4.0~a8-1
Date: Sun, 10 Mar 2013 18:17:31 +0000
Source: live-boot
Source-Version: 4.0~a8-1

We believe that the bug you reported is fixed in the latest version of
live-boot, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 702421@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Baumann <daniel@debian.org> (supplier of updated live-boot package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 10 Mar 2013 19:02:23 +0100
Source: live-boot
Binary: live-boot live-boot-doc live-boot-initramfs-tools
Architecture: source all
Version: 4.0~a8-1
Distribution: experimental
Urgency: low
Maintainer: Debian Live Project <debian-live@lists.debian.org>
Changed-By: Daniel Baumann <daniel@debian.org>
Description: 
 live-boot  - Live System Boot Scripts
 live-boot-doc - Live System Boot Scripts (documentation)
 live-boot-initramfs-tools - Live System Boot Scripts (initramfs-tools backend)
Closes: 702421
Changes: 
 live-boot (4.0~a8-1) experimental; urgency=low
 .
   [ Daniel Baumann ]
   * Moving initramfs-tools entry-point to backends.
   * Moving dracut entry-point stub to backends.
   * Dropping pre-squeeze udev conditionals in initramfs-tools hook.
   * Dropping conditionals in backend, stuff is either there or not but not
     nothing in between.
   * Correcting spelling typos, thanks to Adam D. Barratt <adam@adam-
     barratt.org.uk>.
 .
   [ Evgeni Golov ]
   * Fixing invalid syntax in test for opt_link.
   * Checking for ${overlay}, not ${device} when trying to close
     ${overlay}.
   * Transforming link targets so they work after the mount was moved
     (Closes: #702421).
Checksums-Sha1: 
 b2864591f2dcda532f558eccd9aab43cc5656cdf 1376 live-boot_4.0~a8-1.dsc
 6edb0f9d3d12622fb92bf9c7d3e80070c6c58228 58304 live-boot_4.0~a8.orig.tar.xz
 5426b1cea470681ada33406e8781d0295e4dceaa 22756 live-boot_4.0~a8-1.debian.tar.xz
 e5189a07f74880d33fd5a3e4e646103951e0aa5e 48858 live-boot_4.0~a8-1_all.deb
 fa08a4bb53beef83532eaeec95fb6acf1692d9ba 51940 live-boot-doc_4.0~a8-1_all.deb
 344f2dc4818073a48a47ca74684446690db0a23b 26858 live-boot-initramfs-tools_4.0~a8-1_all.deb
Checksums-Sha256: 
 9c6c32e4de2b630cf53e80c61466bec158ab477fcc9a5a5f9a09962afb3eebfa 1376 live-boot_4.0~a8-1.dsc
 89344388c3b90d4e0c9f1ffe703605e0e91195c036cf42fe1abf570760c6ea3d 58304 live-boot_4.0~a8.orig.tar.xz
 7f9250886abf992a5ddde19263f2f7566bdb60c2e78be14ff953a785b920ce08 22756 live-boot_4.0~a8-1.debian.tar.xz
 45c7839b3aad2672f9f8981de6032b4d18f4e4955a438a75859d5f7a56b5a5dc 48858 live-boot_4.0~a8-1_all.deb
 6a54bd22624c54cd537cfae2e43b84808efb526dff3133edd81e6be922a61ade 51940 live-boot-doc_4.0~a8-1_all.deb
 ad6b40040661123f445b74e9f936e7599d60389fd2d9b53f5873ec14c7777c9d 26858 live-boot-initramfs-tools_4.0~a8-1_all.deb
Files: 
 c31681ddb1bffed3ad3a8723ef5912fa 1376 misc optional live-boot_4.0~a8-1.dsc
 96b2ea491a42de84bdd08d561f204ccf 58304 misc optional live-boot_4.0~a8.orig.tar.xz
 d4280ef1888692ee4540f39e774f51ab 22756 misc optional live-boot_4.0~a8-1.debian.tar.xz
 1269d7b7d59addffaae0194e2d0bf198 48858 misc optional live-boot_4.0~a8-1_all.deb
 1c27510a6289ddbb289b69364ff17ae1 51940 doc optional live-boot-doc_4.0~a8-1_all.deb
 598f58149cdfcc9e3475989494d50610 26858 misc optional live-boot-initramfs-tools_4.0~a8-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAlE8y4AACgkQ+C5cwEsrK56RXgCg1HcTUVUwiGNuw3vMidVaAbhH
yY0An1hbyxIsoRVYU+VkkCyD9F4LzVCN
=lc+C
-----END PGP SIGNATURE-----




Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 11:06:50 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.